use lib "$ENV{FIREDIR}/SCRIPTS";

use strict;
use Getopt::Long;

my $expfile = undef;
my $outfile = undef;
GetOptions('expfile=s'   => \$expfile,
	   'outfile=s'   => \$outfile);

my %TU;
my %count;
open I, "< /home/goodarzi/FIREv1.1/FIRE_DATA/ECOLI/SCRIPTS/TranscriptionUnits.txt";
while(<I>)
{
    chomp;
    my($tu, @g) = split(/\t/, $_);
    $TU{$tu}->{genes} = \@g ;
    $TU{$tu}->{count} = scalar(@g) ;
}

if (! (defined $outfile))
{
    $outfile = $expfile.".tu";
}
open EXP, "< $expfile" or "Couldn't find $expfile";
my $H = <EXP>;
chomp $H;
my %data ;
while(<EXP>)
{
    chomp;
    my ($g, @a) =  split(/\t/, $_);
    $data{$g} = \@a ;
}

my %tu_data ;
foreach my $tu (sort keys %TU)
{
    my $genes = $TU{$tu}->{genes} ;
    foreach my $g (@$genes)
    {
	print $g, "\t" ;
	next if (! defined $data{$g}) ;
	for (my $i=0 ; $i<@{$data{$g}} ; $i++)
	{
	    $tu_data{$tu}->[$i] = $data{$g}->[$i]/$TU{$tu}->{count} ;
	}
    }
}
open OUT, "> $outfile" or die "Couldn't open $outfile";
print OUT $H, "\n";
foreach my $tu (sort keys %tu_data)
{
    my @a = @{$tu_data{$tu}};
    print OUT $tu, "\t", join("\t",@a),"\n" ;
}
